<template lang="pug">
.border(:class="{'col-3':!large,'col-6':large}").relative-position
  .countdown.absolute-center.text-red.z-max(v-show="countdown>0" style="font-size:1.3em;") live in {{Math.round(countdown/1000)}}...
  div.live(:class="{'on':content.live}")
    //- div {{content.id}}
    //- div {{content.live}}
    //- div {{content.played}}
    //- div {{sources[0]}}
    //- div {{sources}}
    //- q-video(:src="`https://www.youtube.com/embed/${youtube}?showinfo=0&modestbranding=1&controls=0&rel=0&autoplay=1&loop=1&cc_load_policy=1&cc_lang_pref=${content.language}&mute=1&playlist=${youtube}&cc=1`" v-if="youtube" :ratio="16/9")
    //- div {{tracks}}
    q-media-player(
      v-if="!hasError && !content.dummy"
      v-show="show"
      :volume="100"
      @ended="ended"
      cross-origin="anonymous"
      @ready="ready"
      @mediaPlayer="playerReady"
      @error="error"
      @networkState="netState"
      @stalled="stalled"
      @playing="playing"
      ref="player"
      type="video"
      :ratio="16/9"
      :no-controls="true"
      :playsinline="true"
      background-color="black"
      :muted="!content.live"
      :autoplay="shouldautoplay"
      :track-language="showTrack"
      :tracks="tracks.items"
      :show-spinner="false"
      :source="source")
    q-img(v-show="(!show || hasError) || content.dummy" :ratio="16/9" :src="staticSource")
    

  .bg-black.q-px-xs(v-if="content.submitted_by" :class="{'text-on':content.live, 'text-red':!content.live}")
    //- div Live: {{content.live}}
    //- div Played: {{content.played}}
    div.small_lcd.ellipsis {{content.submitted_by.user_name}}
    div.small_lcd {{getRegion(content.region)}}

  .bg-black.q-px-xs.text-grey-7(v-if="content.dummy")
    div.small_lcd Connecting to remote reporter.
    div.small_lcd Sourcing connection channel...
    
  
</template>

<script>
import { find } from "lodash";
import { ifrcList } from "ifrc-list";
let langmap = require("langmap");

export default {
  props: ["size", "large", "content", "cfurl"],

  data() {
    return {
      functionsUrl: process.env.VUE_APP_FUNCTION_URL,
      hasError: false,
      show: false,
      // messageShown: false,
      countdown: 0,
      donetimeout: false,
      player_ready: false,
      shouldautoplay: false,
      tracks: {
        items: [],
      },
      showTrack: "Off",
    };
  },
  computed: {
    staticSource() {
      if (this.content.dummy) {
        return "vid/video.gif";
      } else {
        return "vid/test4.gif";
      }
    },
    image() {
      if (this.src) return this.src;
      else return "/img/test.jpg";
    },
    id() {
      return this.content.id;
    },
    // youtube() {
    // return id;

    // if (this.content.media)
    //   return find(this.content.media, { type: "hd_video" }).src.replace(
    //     "hd_video",
    //     "hd_video_tiny"
    //   );
    // else return false;
    // },
    // tracks() {
    //   return [
    //     {
    //       src: `${this.functionsUrl}/getSubtitles?submission=${this.id}`,
    //       kind: "subtitles",
    //       srcLang: "en",
    //       label: "Captions",
    //     },
    //   ];
    // },
    source() {
      // console.log("updated sources");
      //s3://youth-innovation/submissions/spkzvDEZaeqV7yWen9Ni/g70Gjnb3o8gkN2PKj8Qb/hd_video.mp4
      if (this.content?.id) {
        try {
          // const url = this.content.id.split("/");

          return `${this.cfurl}/submissions/${this.content.id}/hd_video_tiny.mp4`;
        } catch (e) {
          return null;
        }
      } else {
        return null;
      }
    },
  },
  watch: {
    // tracks: {
    //   handler() {
    //     console.log("TRACK CHANGED");
    //     // var tracks = player.textTracks();

    //     // for (var i = 0; i < tracks.length; i++) {
    //     //   var track = tracks[i];

    //     //   // Find the English captions track and mark it as "showing".
    //     //   if (track.kind === 'captions' && track.language === 'en') {
    //     //     track.mode = 'showing';
    //     //   }
    //     // }
    //   },
    // },
    source: {
      handler() {
        // console.log(this.$refs.player.$media);
        if (this.$refs.player) {
          var tracks = this.$refs.player.$media.textTracks;

          for (var i = 0; i < tracks.length; i++) {
            var track = tracks[i];
            console.log("hiding track");
            track.mode = "hidden";
          }
        }

        this.showTrack = "Off";
        this.show = false;
        this.donetimeout = false;
        this.$set(this.tracks, "items", []);
        console.log("reload", this.source);
        // console.log(this.sources);
        //player ready:
        // if (this.player_ready) this.caughtplay();
      },
    },
    "content.live": {
      handler() {
        console.log("live changed ", this.content.live, this.sources);
        if (!this.content.dummy && this.content.live === true) {
          // console.log(this.content);

          console.log("Its live so play from start now.");
          try {
            if (this.$refs.player) this.$refs.player.setCurrentTime(0);
          } catch (e) {
            console.log(e);
            if (this.$refs.player) this.$refs.player.play();
          }
          // try {
          // this.$refs.player.play();
          // this.caughtplay();
          // } catch (e) {
          //show when it cant play

          // console.log("SHOW INTERACTION MESSAGE");
          // }
        }
      },
    },
  },
  methods: {
    playerReady() {
      console.log("player ready");
      this.player_ready = true;
      this.playme();
      // if (this.content.live) {
      //   this.$refs.player.play();
      //   // console.log(this.youtube);
      //   // console.log(this.content);
      //   // this.$refs.player.play();
      // }
    },
    runTicker() {
      setTimeout(() => {
        if (this.countdown <= 0) {
          console.log("showing");
          this.countdown = 0;
          this.show = true;
          this.$refs.player.play();
        } else {
          this.countdown = this.countdown - 500;
          this.runTicker();
        }
      }, 500);
    },
    playing() {
      // if (this.messageShown) {
      //   this.messageShown();
      //   this.messageShown = false;
      // }
      this.shouldautoplay = true;
    },
    stalled() {
      console.log("stalled");
    },
    netState(s) {
      console.log("netstate", s);
    },
    error(e) {
      console.log(e, "moving to next vid");
      this.hasError = true;
      this.$emit("cant-play");
    },
    getRegion(reg) {
      return find(ifrcList, { code: reg }).ns;
    },
    getLang(lang) {
      return langmap[lang].englishName;
    },
    ended() {
      // console.log("restart");
      this.$refs.player.setCurrentTime(0);
      this.$refs.player.play();
      this.$emit("video-ended");
    },
    ready() {
      console.log("ready", this.$refs.player.currentTime());

      //dont loop when scrubbing, otherwise initiate play
      if (this.$refs.player.currentTime() == 0) this.playme();

      this.$set(this.tracks, "items", [
        {
          src: `${this.functionsUrl}/getSubtitles?submission=${this.id}`,
          kind: "subtitles",
          srcLang: "en",
          label: this.id,
        },
      ]);
      this.showTrack = this.id;
    },
    playme() {
      // console.log(event);
      // this.caughtplay();

      //random delay up to 6s
      console.log("islive", this.content.live);

      let timeout = 0;
      if (!this.content.live && !this.donetimeout) {
        timeout = Math.round(Math.random() * 14) * 500 + 2000;
        this.donetimeout = true;
      }

      console.log("play me", timeout);

      // console.log(timeout);
      this.countdown = timeout;

      this.runTicker();
    },
    // caughtplay() {
    //   try {
    //     console.log("trying to play");
    //     this.$refs.player.play();
    //   } catch (e) {
    //     console.log(e);
    //     console.log("SHOW INTERACTION MESSAGE");
    //     this.messageShown = this.$q.notify({
    //       type: "warning",
    //       classes: "text-h3",
    //       timeout: 0,
    //       position: "top",
    //       message: "Please click play on the green video to continue...",
    //     });
    //   }
    // },
  },
};
</script>
<style lang="scss">
@import "@/styles/quasar.variables.scss";

.small_lcd {
  font-size: 10px;
}

.border {
  border: solid 2px transparent;
}

.live {
  border: solid 8px $grey-10;
}

@keyframes borderBlink {
  from,
  to {
    border-color: transparent;
  }
  50% {
    border-color: greenyellow;
  }
}

.on {
  animation: borderBlink 1s normal infinite ease-in-out;
  // border-color: greenyellow;
}

.text-on {
  color: greenyellow;
}

.insets {
  box-shadow: inset 0px 0px 10px 0px #610000;
}
</style>
